# include <bits/stdc++.h>
# define ll long long
using namespace std;

const ll MAXN = 2 * 1e5 + 1;
ll N, M;
priority_queue<tuple<ll, ll, ll>> Pq;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(ll i = 0; i < N; i++)
    {
        ll t, k; cin >> t >> k;
        Pq.push({-k, t, i + 1});
    }
}

void Solve()
{
    vector<ll> Answer;
    ll Counter = 0;
    ll Used = 0;
    ll Day = 1;

    while(!Pq.empty())
    {
        ll k, t, Index;
        tie(k, t, Index) = Pq.top();
        k *= -1;
        Counter = (ll)(M * Day) - (ll)Used;

        if(Day > t)
        {
            Pq.pop();
            continue;
        }
        else
        {
            ll Need = k - Counter;
            ll Add = 0;

            if(Need <= 0)
            {
                Answer.push_back(Index);
                Used += k;
                Pq.pop();
                continue;
            }
            else
            {
                Day++;
                continue;
            }
        }
    }

    if(Answer.empty())
    {
        cout << 0;
    }
    else
    {
        cout << (int)Answer.size() << '\n';
        for(auto& U : Answer) cout << U << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

