# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
ll N, M;
tuple<ll, ll, int> A[MAXN];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < N; i++)
    {
        cin >> get<0>(A[i]) >> get<1>(A[i]);
        get<2>(A[i]) = i + 1;
    }

    sort(A, A + N);
}

vector<int> Flow;
vector<int> Answer;

void f(ll Day, ll Current)
{
    for(int i = 0; i < N; i++)
    {
        if(get<1>(A[i]) <= Current + (get<0>(A[i]) - Day) * M)
        {
            if(!Flow.empty())
            {
                if(Flow.back() == get<2>(A[i])) continue;
            }

            Flow.push_back(get<2>(A[i]));

            if(Answer.empty() || (int)Answer.size() < (int)Flow.size())
            {
                Answer = Flow;
            }

            f(get<0>(A[i]), (ll)(Current + (ll)((get<0>(A[i]) - Day) * M) - (ll)get<1>(A[i])));
            Flow.pop_back();
        }
    }
}

void Solve()
{
    f(0, 0);
    if(Answer.empty())
    {
        cout << 0 << '\n';
    }
    else
    {
        cout << (int)Answer.size() << '\n';
        for(auto& U : Answer) cout << U << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
