# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
ll N, M;
ll T[MAXN], K[MAXN];
bool Mark[MAXN];
vector<tuple<ll, ll, int>> A;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < N; i++)
    {
        cin >> T[i] >> K[i];
        A.push_back({K[i], T[i], i});
    }

    sort(A.begin(), A.end());
}

void Solve()
{
    vector<int> Answer;

    for(int i = 0; i < N; i++)
    {
        int j = get<2>(A[i]);
        int Free = 0;

        for(int Time = T[j]; Time >= 1; Time--)
        {
            if(!Mark[Time])
            {
                Free++;
            }
        }

        if(Free >= K[j])
        {
            Answer.push_back(j + 1);

            for(int Time = T[j]; Time >= 1; Time--)
            {
                if(K[j] == 0) break;
                if(!Mark[Time])
                {
                    Mark[Time] = true;
                    K[j]--;
                }
            }
        }
    }


    if(Answer.empty())
    {
        cout << 0 << '\n';
    }
    else
    {
        cout << (int)Answer.size() << '\n';
        for(auto& U : Answer) cout << U << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
