#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX = (3e6) + 5;

int a[MAX], f[MAX], bb[MAX], bc[MAX], n;

void Update(int k, int delta)
{
    while (k <= n)
    {
        f[k] += delta;
        k += k & (-k);
    }
}

int Q(int k)
{
    int ret = 0;
    while (k >= 1)
    {
        ret += f[k];
        k -= k & (-k);
    }
    return ret;
}

void Solve()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        Update(i, 1);
    }
    long long op, inv = 0;
    for (int i = n; i >= 1; i--)
    {
        op = Q(a[i]);
        bb[a[i]] = Q(n) - op;
        bc[a[i]] = a[i] - op;
        inv += bc[a[i]];
        Update(a[i], -1);
    }

    long long cnt = 0, best, bestC = 0;
    for (int i = 1; i <= n; i++)
    {
        cnt += bb[i] - bc[i - 1];
        bestC = max(bestC, cnt);
    }
    cout << inv - bestC << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    Solve();
    return 0;
}