#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const long long MAX = (2e5) + 5;

long long n, m;

struct Cell
{
    long long t, k, ind;
} a[MAX];

bool Cmp(Cell a, Cell b)
{
    return a.t < b.t;
}

vector<Cell> v, maxv;

bool Check()
{
    sort(v.begin(), v.end(), Cmp);
    long long op = 0;
    for (long long i = 0; i < v.size(); i++)
    {
        op += v[i].k;
        if (op > v[i].t * m)
            return 0;
    }
    return 1;
}

void Solve()
{
    cin >> n >> m;
    for (long long i = 1; i <= n; i++)
    {
        cin >> a[i].t >> a[i].k;
        a[i].ind = i;
    }

    for (long long b = 0; b < (1 << n); b++)
    {
        v.clear();
        for (long long i = 0; i < n; i++)
        {
            if (bool((1 << i) & b) == 1)
                v.push_back(a[i + 1]);
        }
        if (v.size() > maxv.size() && Check())
            maxv = v;
    }
    cout << maxv.size() << endl;
    for (long long i = 0; i < maxv.size(); i++)
        cout << maxv[i].ind << " ";
    cout << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    Solve();
    return 0;
}