#include<bits/stdc++.h>
#define endl '\n'
#define int long long int

using namespace std;
const int maxn = 1e5 + 4;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
int n, a[maxn], b[maxn];
void read()
{
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
}
int ans;
void merge_sort(int l, int r, vector<int> &curr)
{
    if(l + 1 == r)return;
    int mid = l  + (r - l)/2;
    merge_sort(l, mid, curr);
    merge_sort(mid, r, curr);
    for(int i = l; i < r; i++)b[i] = curr[i];
    int x = l, y = l, z = mid;
    while(y < mid && z < r)
    {
        if(b[y] < b[z])curr[x++] = b[y++];
        else
        {
            ans += (mid - y);
            curr[x++] = b[z++];
        }
    }
    while(y < mid)curr[x++] = b[y++];
    while(z < r)curr[x++] = b[z++];
}
void solve()
{
    vector<int> curr(n);
    int mindiff = 1e9;
    int cur = 0;
    for(int k = 0; k < n; k++)
    {
        curr.clear();
        memset(b, 0, sizeof(b));
        cur = 0;
        int p = k;
        for(int j = 0; j < n; j++)
        {
            if(a[p] > a[j])curr.push_back(a[j]);
        }
        curr.push_back(a[p]);
        for(int j = 0; j < n; j++)
        {
            if(a[p] < a[j])curr.push_back(a[j]);
        }
        merge_sort(0, n, curr);
        cur = ans;
        mindiff = min(mindiff, cur);
    }
    //cout << endl;
    cout << mindiff << endl;
}
signed main()
{
    speed();
    read();
    solve();
    return 0;
}
