#include <bits/stdc++.h>
using namespace std;
const long long MAXN=5009;
long long mas[MAXN];

long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

long long lp2(long long a)
{
    return a&(-a);
}

struct fenwick
{
    long long fenwick[MAXN];
    void change(int a,int b)
    {
        while(a<MAXN)
        {
            fenwick[a]+=b;
            a+=lp2(a);
        }
    }

    long long query(int a)
    {
        long long ans=0;
        while(a>0)
        {
            ans+=fenwick[a];
            a-=lp2(a);
        }
        return ans;
    }

    long long getAns(long long a,long long b)
    {
        return query(b)-query(a-1);
    }

    void clearFen()
    {
        for(int i=0;i<MAXN;i++)fenwick[i]=0;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long N,rAns=LLONG_MAX;
    fenwick fenSmall, fenBig;
    cin>>N;
    for(int i=0;i<N;i++)
    {
        cin>>mas[i];
    }

    for(int i=0;i<N;i++)
    {
        long long ans=0;
        fenSmall.clearFen();
        fenBig.clearFen();
        for(int j=0;j<N;j++)
        {
            if(i==j)continue;
            if(mas[i]>mas[j])
            {
                ans+=fenSmall.getAns(mas[j],MAXN-1);
                fenSmall.change(mas[j],1);
            }
            else
            {
                ans+=fenBig.getAns(mas[j],MAXN-1);
                fenBig.change(mas[j],1);
            }
        }
        rAns=min1(rAns,ans);
    }

    cout<<rAns<<endl;

    return 0;
}
