#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#define endl '\n'

using namespace std;

struct Provision {
    long long t, k, index;
};

bool cmp(Provision p, Provision q)
{
    return p.t < q.t;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, m;
    cin >> n >> m;
    vector <Provision> provisions;
    for (int i = 0; i < n; i++)
    {
        long long t, k;
        cin >> t >> k;
        provisions.push_back({ t, k, i + 1 });
    }
    sort(provisions.begin(), provisions.end(), cmp);
    vector <long long> result;
    for (auto p : provisions)
    {
        if (p.k <= p.t)
        {
            result.push_back(p.index);
        }
    }

    cout << result.size() << endl;
    if (!result.empty())
    {
        sort(result.begin(), result.end());
        for (int i : result)
        {
            cout << i << " ";
        }
        cout << endl;
    }
}

