# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 3 * 1e6 + 1;
const int INF = 1e9;
int N;
int A[MAXN];
int Answer = INF;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;
    for(int i = 0; i < N; i++) cin >> A[i];
}

void Query(int Mid)
{
    vector<int> Tree(N + 1, 0);
    vector<int> Left;
    vector<int> Right;

    for(int i = 0; i < N; i++)
    {
        if(A[i] < A[Mid])
        {
            Left.push_back(A[i]);
        }
        else if(A[i] > A[Mid])
        {
            Right.push_back(A[i]);
        }
    }

    int Current = 0;

    for(auto& Value : Left)
    {
        int Index = Value + 1;
        int Sum = 0;

        while(Index <= N)
        {
            Sum += Tree[Index];
            Index += (Index & (-Index));
        }


        Current += Sum;
        Index = Value;

        while(Index >= 1)
        {
            Tree[Index]++;
            Index -= (Index & (-Index));
        }
    }

    for(auto& Value : Right)
    {
        int Index = Value + 1;
        int Sum = 0;

        while(Index <= N)
        {
            Sum += Tree[Index];
            Index += (Index & (-Index));
        }


        Current += Sum;
        Index = Value;

        while(Index >= 1)
        {
            Tree[Index]++;
            Index -= (Index & (-Index));
        }
    }

    Answer = min(Answer, Current);
}

void Solve()
{
    for(int Mid = 0; Mid < N; Mid++) Query(Mid);
    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
