# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
ll N, M;
priority_queue<tuple<ll, ll, int>> Pq;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < N; i++)
    {
        ll t, k; cin >> t >> k;
        Pq.push({-k, t, i + 1});
    }
}

void Solve()
{
    vector<int> Answer;
    ll Counter = 0;
    ll Used = 0;
    ll Day = 0;

    while(!Pq.empty())
    {
        ll k, t, Index;
        tie(k, t, Index) = Pq.top();
        k = -k;

        if(Day > t)
        {
            Pq.pop();
            continue;
        }
        else
        {
            ll Need = k - Counter;
            ll Add = 0;

            if(Need <= 0)
            {
                Answer.push_back(Index);
                Counter -= k;
                Pq.pop();
            }
            else
            {
                Add = (ll)((Need) / (M));
                if(Need % M != 0) Add++;
                Counter += Add * M;
                Day += Add;
                continue;
            }
        }
    }

    if(Answer.empty())
    {
        cout << 0 << '\n';
    }
    else
    {
        cout << (int)Answer.size() << '\n';
        for(auto& U : Answer) cout << U << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
