# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
ll N, M;
ll T[MAXN];
ll K[MAXN];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < N; i++)
    {
        cin >> T[i] >> K[i];
    }
}

bool Check(vector<int>& Flow)
{
    vector<pair<ll, ll>> Current;

    for(auto& U : Flow)
    {
        Current.push_back({T[U - 1], K[U - 1]});
    }

    sort(Current.begin(), Current.end());

    ll Used = 0;

    for(int i = 0; i < (int)Current.size(); i++)
    {
        ll Value = Current[i].first * M - Used;

        if(Value < Current[i].second) return false;
        Used += Current[i].second;
    }

    return true;
}

void Solve()
{
    ll MAXMASK = (1 << N);
    vector<int> Answer;

    for(int Mask = 0; Mask < MAXMASK; Mask++)
    {
        vector<int> Current;

        for(int Bit = 0; Bit < N; Bit++)
        {
            if((Mask & (1 << Bit)))
            {
                Current.push_back(Bit + 1);
            }
        }

        if(!Current.empty() && Check(Current))
        {
            if(Answer.empty() || (int)Answer.size() < (int)Current.size())
            {
                Answer = Current;
            }
        }
    }

    if(Answer.empty())
    {
        cout << 0 << '\n';
    }
    else
    {
        cout << (int)Answer.size() << '\n';
        for(auto& U : Answer) cout << U << ' ';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
