#include <bits/stdc++.h>
#define endl '\n'

using ll = long long;
using namespace std;

const int N = 3e6 + 5;

int n;
int a[N], pos[N];
ll L[N], R[N];
ll val[N][2];
ll bit[N][2];

void update(int idx, int x, int id)
{
    while (idx <= n)
    {
        bit[idx][id] += x;
        idx += idx & (-idx);
    }
}

ll query(int idx, int id)
{
    ll sum = 0;

    while (idx >= 1)
    {
        sum += bit[idx][id];
        idx -= idx & (-idx);
    }

    return sum;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];

        pos[a[i]] = i;
    }

    for (int i = n; i >= 1; i--)
    {
        val[a[i]][0] = query(a[i] - 1, 0);
        update(a[i], 1, 0);
    }

    for (int i = 1; i <= n; i++)
    {
        val[a[i]][1] = i - query(a[i], 1) - 1;
        update(a[i], 1, 1);
    }

    ll cnt = 0;

    for (int i = 1; i < n; i++)
    {
        cnt += val[i][0];
        L[i] = cnt;
    }

    cnt = 0;

    for (int i = n; i >= 2; i--)
    {
        cnt += val[i][1];
        R[i] = cnt;
    }

    ll ans = LLONG_MAX;

    for (int mid = 1; mid <= n; mid++)
    {
        ans = min(ans, L[mid - 1] + R[mid + 1]);
    }

    cout << ans << endl;

    return 0;
}