#include <bits/stdc++.h>
#define endl '\n'

using ll = long long;
using namespace std;

const int N = 2e5 + 5;

struct Pair
{
    ll t, k;
    int id;

    bool operator < (const Pair &other)
    {
        if (k == other.k)
        {
            return t < other.t;
        }

        return k < other.k;
    }
};

bool cmp(Pair &a, Pair &other)
{
    if (a.t == other.t)
    {
        return a.k < other.k;
    }

    return a.t < other.t;
}

ll n, m;
Pair p[N];
ll days;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++)
    {
        cin >> p[i].t >> p[i].k;

        p[i].id = i;
        days = max(days, p[i].t);
    }

    if (m != 1)
    {
        sort(p + 1, p + n + 1);
    }
    else
    {
        sort(p + 1, p + n + 1, cmp);
    }

    ll more = 0;
    ll currDay = 0;
    vector <int> ans;

    for (int i = 1; i <= n; i++)
    {
        ///cout << "I: " << i << endl;

        if ((p[i].t - currDay) * m + more >= p[i].k)
        {
            if (more >= p[i].k)
            {
                ans.push_back(p[i].id);
                more -= p[i].k;

                continue;
            }

            if ((p[i].t - currDay) * m < p[i].k)
            {
                ///cout << "go if 1" << endl;

                ans.push_back(p[i].id);
                more -= p[i].k - ((p[i].t - currDay) * m);
                currDay = p[i].t;
            }
            else
            {
                ///cout << "go if 2" << endl;

                ll rem = p[i].k;
                ll d = rem / m;

                if (rem % m > 0)
                {
                    d++;
                }

                if (currDay + d > p[i].t)
                {
                    continue;
                }

                currDay += d;
                more += (d) * m - p[i].k;
                ans.push_back(p[i].id);
                ///currDay += d;

                continue;
            }
        }
    }

    cout << ans.size() << endl;

    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i] << " ";
    }

    return 0;
}
/**
5 1
1 2
2 3
33 4
4 5
5 6
**/
