#include <bits/stdc++.h>
using namespace std;
const int MAXN=3000009;
int mas[MAXN];
int pos[MAXN];
long long ansSmall[MAXN];
long long ansBig[MAXN];

long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

int lp2(int a)
{
    return a&(-a);
}

struct fenwick
{
    long long fenwick[MAXN];
    void change(int a,int b)
    {
        while(a<MAXN)
        {
            fenwick[a]+=b;
            a+=lp2(a);
        }
    }

    long long query(int a)
    {
        long long ans=0;
        while(a>0)
        {
            ans+=fenwick[a];
            a-=lp2(a);
        }
        return ans;
    }

    long long getAns(long long a,long long b)
    {
        return query(b)-query(a-1);
    }

    void clearFen()
    {
        for(int i=0;i<MAXN;i++)fenwick[i]=0;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long N,rAns=LLONG_MAX;
    fenwick fen;
    cin>>N;
    for(int i=0;i<N;i++)
    {
        cin>>mas[i];
        pos[mas[i]]=i+1;
    }
    fen.clearFen();
    for(int i=1;i<N;i++)
    {
        ansSmall[i]=ansSmall[i-1]+fen.getAns(pos[i],MAXN-1);
        fen.change(pos[i],1);
    }
    fen.clearFen();
    for(int i=N;i>0;i--)
    {
        ansBig[i]=ansBig[i+1]+fen.getAns(1,pos[i]);
        fen.change(pos[i],1);
    }
    for(int i=0;i<N;i++)
    {
        rAns=min1(rAns,ansSmall[i]+ansBig[i+2]);
    }
    cout<<rAns<<endl;
    return 0;
}
