#include <bits/stdc++.h>
using namespace std;
const long long MAXN=100009;
const long long MOD=1000000007;
long long father[MAXN];
long long dist[MAXN];
long long posi[MAXN];
long long dp[MAXN][40];
vector<int> edg[MAXN];
vector<int> child[MAXN];
vector<pair<int,int>> pret[MAXN];

long long f(int n,int p)
{
    if(dp[n][p]!=-1)return dp[n][p];
    if(p==0)return dp[n][p]=father[n];
    return dp[n][p]=f(f(n,p-1),p-1);
}

pair<int,int> lca(int a,int b)
{
    if(dist[a]>dist[b])swap(a,b);
    for(int i=30;i>=0;i--)
    {
        if(dist[f(b,i)]>=dist[a])b=f(b,i);
    }
    for(int i=30;i>=0;i--)
    {
        if(f(b,i)!=f(a,i))
        {
            a=f(a,i);
            b=f(b,i);
        }
    }
    return {a,b};
}

void dfs(int start,int d)
{
    dist[start]=d;
    for(auto i:edg[start])
    {
        if(dist[i]!=-1)
        {
            father[start]=i;
            continue;
        }
        child[start].push_back(i);
        dfs(i,d+1);
    }
    sort(child[start].begin(),child[start].end());
}

long long solve(int a)
{
    long long ans=0;
    do
    {
        bool pos=1;
        for(int i=0;i<child[a].size();i++)posi[child[a][i]]=i;
        for(auto i:pret[a])pos&=(posi[i.first]<posi[i.second]);
        ans+=pos;

    }while(next_permutation(child[a].begin(),child[a].end()));

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    memset(dp,-1,sizeof(dp));
    memset(dist,-1,sizeof(dist));
    long long N,M,a,b,ans=1;
    bool flag=0;
    cin>>N>>M;
    for(int i=1;i<N;i++)
    {
        cin>>a>>b;
        edg[a].push_back(b);
        edg[b].push_back(a);
    }
    father[1]=1;
    dfs(1,0);
    while(M--)
    {
        cin>>a>>b;
        auto x=lca(a,b);
        if(father[x.first]==b)
        {
            flag=1;
            continue;
        }
        if(father[x.first]==a)
        {
            continue;
        }
        pret[father[x.first]].push_back({x.first,x.second});
    }
    if(flag)
    {
        cout<<0<<endl;
        return 0;
    }

    for(int i=1;i<=N;i++)
    {
        ans=(ans*solve(i))%MOD;
    }

    cout<<ans<<endl;

    return 0;
}
