#include<bits/stdc++.h>
using namespace std;
const long long module = 1e9 + 7;
const long long MAX_N = 100000;
vector<vector<long long> > adj;
vector<bool> visited;
long long fact[MAX_N];
long long ans = 1;
void factoriels(long long N)
{
    fact[0] = 1;
    for(int i = 1; i <= N; i++)
    {
        fact[i] = fact[i - 1] * i % module;
    }
}
void dfs(long long node)
{
    visited[node] = true;
    ans = ans * fact[adj[node].size() - 1] % module;
    for(auto i: adj[node])
    {
        if(visited[i] == false)
        {
            dfs(i);
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long N, M, u, v;
    cin>>N>>M;
    adj.resize(N + 1);
    for(long long i = 0; i < N - 1; i++)
    {
        cin>>u>>v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    visited.assign(N + 1, false);
    factoriels(N);
    dfs(1);
    ans *= adj[1].size();
    for(long long i = 0; i < M; i++)
    {
        cin>>u>>v;
        ans /= 2;
    }
    cout<<ans<<endl;
    return 0;
}
