#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#define endl '\n'

using namespace std;

int calc(vector <int>& A)
{
    int d = 0;
    int n = A.size();
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            if (A[i] > A[j])
            {
                d++;
            }
        }
    }
    return d;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <int> A(n);
    for (int i = 0; i < n; i++)
    {
        cin >> A[i];
    }
    vector <int> sortedA = A;
    sort(sortedA.begin(), sortedA.end());
    int minD = INT_MAX;
    for (int p = 0; p < n; p++)
    {
        int ind = A[p];
        int lessCnt = lower_bound(sortedA.begin(), sortedA.end(), ind) - sortedA.begin();
        int greaterCnt = n - lessCnt - 1;
        
        int d = 0;
        for (int i = 0; i < p; i++)
        {
            if (A[i] > ind) d++;
        }
        for (int i = p + 1; i < n; i++)
        {
            if (A[i] < ind) d++;
        }
        minD = min(minD, d);
    }
    cout << minD << endl;
}

