#include <iostream>
#include <vector>
#include <algorithm>
#define days first.first
#define cnt first.second
#define endl '\n'

using namespace std;

vector < pair < pair <int, int>, pair <int, int>> > v;

bool cmp(pair < pair <int, int>, pair <int, int>> p, pair < pair <int, int>, pair <int, int>> q)
{
    if (p.second.first != q.second.first) return p.second.first < q.second.first;
    return p.days < q.days;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        int t, k; // long long
        cin >> t >> k;
        v.push_back({ {t, k}, {k / t, i + 1} });
    }
    sort(v.begin(), v.end(), cmp);
    int day = 1, i = 0, food = m, br = 0;
    while (true)
    {
        if (v[i].days >= day)
        {
            if (v[i].cnt == 0)
            {
                i++;
                continue;
            }
            if (v[i].cnt >= food)
            {
                v[i].cnt -= food;
                day++;
                continue;
            }
            else
            {
                v[i].cnt = 0;
                br++;
                food -= v[i].cnt;
                continue;
            }
        }
        else
        {
            break;
        }
    }
    cout << br << endl;
    for (int i = 0; i < v.size(); i++)
    {
        if (v[i].cnt == 0) cout << v[i].second.second << endl;
        else break;
    }
}
