#include <bits/stdc++.h>
using namespace std;

int n;

int findDisorder(vector<int> real) {
    int p = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (real[i] > real[j])
                p++;
        }
    }
    return p;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;

    vector<int> A(n+1);

    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }

    int disorder = INT_MAX;
    for (int i = 0; i < n; i++) {
        int p = A[i];
        vector<int> lower, higher;

        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (A[j] < A[i])
                lower.push_back(A[j]);
            else
                higher.push_back(A[j]);
        }

        vector<int> yes;
        yes.insert(yes.end(), lower.begin(), lower.end());
        yes.push_back(p);
        yes.insert(yes.end(), higher.begin(), higher.end());

        disorder = min(disorder, findDisorder(yes));

    }

    cout << disorder;
    return 0;
}