#include <bits/stdc++.h>
using namespace std;

long long n, m;

struct Provision {
    long long t, k, idx;
};
vector<Provision> provisions;

bool compare(Provision a, Provision b) {
    return a.t < b.t;
}

void solve() {
    long long currDay = 0;
    stack<long long> solution;
    for (auto& provision : provisions) {
        long long mandja = (provision.k) / m;
        if (currDay + mandja > provision.t)
            continue;

        solution.push(provision.idx);
        currDay += mandja;
    }

    cout << solution.size() << endl;
    while (!solution.empty()) {
        cout << solution.top() << " ";
        solution.pop();
    }
}

void input() {
    cin >> n >> m;
    provisions.resize(n);
    for (long long i = 0; i < n; i++) {
        cin >> provisions[i].t >> provisions[i].k;
        provisions[i].idx = i + 1;
    }

    sort(provisions.begin(), provisions.end(), compare);
    // otchaivam se 
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    input();
    solve();

    return 0;
}